#include <NewPing.h>



#define ping_interval 35 // Ping frequency (in milliseconds), fastest we should ping is about 35ms per sensor



const int numReadings = 5;



#define SONAR_NUM     4 // Number or sensors.

NewPing sonar[SONAR_NUM] = 

{

NewPing (2, 3, 200), // Sensor 0: trigger pin, echo pin, maximum distance in cm

NewPing (10, 11, 200), // Sensor 1: same stuff

NewPing (6, 7, 200), // Sensor 2: same stuff

NewPing (8, 9, 200) // Sensor 3: same stuff

};



// qsort requires you to create a sort function

int sort_desc(const void *cmp1, const void *cmp2)

{int a = *((int *)cmp1);

int b = *((int *)cmp2);

return a > b ? -1 : (a < b ? 1 : 0);}





int readIndex = 0;            

int indexcount = 0;

int cm[SONAR_NUM];

unsigned long pingTimer[SONAR_NUM];

int pingmin1 = 0;

int pingmin2 = 0;

int pingfinal = 0;

int loopcount = 0;



int ledPin1 =  4;      // the number of the LED pin

int ledState1; //= LOW;             // ledState used to set the LED

long updatetime=600;

unsigned long previousMillis1 = 0;        // will store last time LED was updated

unsigned long previousMillis2 = 0;        // will store last time LED was updated

long OnTime1 = 25;           // milliseconds of on-time

long OffTime1 = 75;          // milliseconds of off-time

long OnTime2 = 25;           // milliseconds of on-time

long OffTime2 =125 ;          // milliseconds of off-time

long OnTime3 = 25;           // milliseconds of on-time

long OffTime3 = 275;          // milliseconds of off-time

long OnTime4 = 25;           // milliseconds of on-time

long OffTime4 = 575;          // milliseconds of off-time





int readings[SONAR_NUM][numReadings];      // the readings from the input

int readings_sorted[SONAR_NUM][numReadings];      // the readings from the input but sorted descending

int lt_length[SONAR_NUM];



int median[SONAR_NUM];



void setup() {

  Serial.begin(9600);

 // Do other stuff here

 pingTimer[0] = millis() + 75; // Sensor 1 fires after 100ms (pingSpeed)

 pingTimer[1] = pingTimer[0] + ping_interval; // Sensor 2 fires 50ms later

 pingTimer[2] = pingTimer[1] + ping_interval; // Sensor 2 fires 50ms later

 pingTimer[3] = pingTimer[2] + ping_interval;

 cm[0]=250;

 cm[1]=250;

 cm[2]=250;

 cm[3]=250;



 for (int thisReading = 0; thisReading < numReadings; thisReading++) {

  readings[SONAR_NUM][thisReading] = 0;}   

  

 pinMode(ledPin1, OUTPUT); 

 ledState1 = LOW;

}



void loop() {



  for (int i = 0; i < SONAR_NUM; i++) 

  {

    if (millis() >= pingTimer[i]) 

    {

      pingTimer[i] = pingTimer[i] + (ping_interval*SONAR_NUM); // Make sensor 1 fire again 100ms later (pingSpeed)

      cm[i] = sonar[i].ping_cm();

     

      if (cm[i]<=0) 

      {cm[i]=200;} 

      else cm[i]=cm[i];



      readings[i][readIndex]=cm[i];

     

      loopcount =loopcount+1;

      if (loopcount >= SONAR_NUM)

      {loopcount = 0;}

      if (loopcount == 0)

        {readIndex = readIndex + 1;

          if (readIndex >= numReadings) 

            {readIndex = 0;}}



      if (loopcount == 0 and readIndex == 0)

        {

          for (int a = 0; a < SONAR_NUM; a++)  

            {

              for (int b = 0; b < numReadings; b++) 

                {readings_sorted[a][b]=readings[a][b];}

              lt_length[a] = sizeof(readings_sorted[a]) / sizeof(readings_sorted[a][1]); 

              qsort(readings_sorted[a], lt_length[a], sizeof(readings_sorted[a][1]), sort_desc);  

              median[a]=readings_sorted[a][2];

            } 

          int min1=min(median[0],median[1]);

          int min2=min(median[2],median[3]);

          pingfinal = min(min1,min2);

          Serial.print("min=");

          Serial.print(pingfinal);

          Serial.print("cm ");

          Serial.println();

         }

    }

  }



  unsigned long currentMillis = millis();



  if (currentMillis - previousMillis1 >= updatetime)

    {previousMillis1 = currentMillis;}



  if (pingfinal >= 0 and pingfinal <= 50) 

    {digitalWrite(ledPin1, HIGH);}



  else if (pingfinal > 50 and pingfinal <= 80)

    {

      if((ledState1 == HIGH) && (currentMillis - previousMillis2 >= OnTime1))

        {

          ledState1 = LOW;  // Turn it off

          previousMillis2 = currentMillis;  // Remember the time

          digitalWrite(ledPin1, ledState1);  // Update the actual LED

        }

  else if ((ledState1 == LOW) && (currentMillis - previousMillis2 >= OffTime1))

{

  ledState1 = HIGH;  // turn it on

  previousMillis2 = currentMillis;   // Remember the time

  digitalWrite(ledPin1, ledState1);    // Update the actual LED

}

}



else if (pingfinal > 80 and pingfinal <= 110)

{

if((ledState1 == HIGH) && (currentMillis - previousMillis2 >= OnTime2))

{

  ledState1 = LOW;  // Turn it off

  previousMillis2 = currentMillis;  // Remember the time

  digitalWrite(ledPin1, ledState1);  // Update the actual LED

}

else if ((ledState1 == LOW) && (currentMillis - previousMillis2 >= OffTime2))

{

  ledState1 = HIGH;  // turn it on

  previousMillis2 = currentMillis;   // Remember the time

  digitalWrite(ledPin1, ledState1);    // Update the actual LED

}

}



else if (pingfinal > 110 and pingfinal <= 140)

{

if((ledState1 == HIGH) && (currentMillis - previousMillis2 >= OnTime3))

{

  ledState1 = LOW;  // Turn it off

  previousMillis2 = currentMillis;  // Remember the time

  digitalWrite(ledPin1, ledState1);  // Update the actual LED

}

else if ((ledState1 == LOW) && (currentMillis - previousMillis2 >= OffTime3))

{

  ledState1 = HIGH;  // turn it on

  previousMillis2 = currentMillis;   // Remember the time

  digitalWrite(ledPin1, ledState1);    // Update the actual LED

}

}



else if (pingfinal > 140 and pingfinal <= 160)

{

if((ledState1 == HIGH) && (currentMillis - previousMillis2 >= OnTime4))

{

  ledState1 = LOW;  // Turn it off

  previousMillis2 = currentMillis;  // Remember the time

  digitalWrite(ledPin1, ledState1);  // Update the actual LED

}

else if ((ledState1 == LOW) && (currentMillis - previousMillis2 >= OffTime4))

{

  ledState1 = HIGH;  // turn it on

  previousMillis2 = currentMillis;   // Remember the time

  digitalWrite(ledPin1, ledState1);    // Update the actual LED

}

}



else {

digitalWrite(ledPin1, LOW);

}

 

}


